<template lang="pug">
	#propiedades
		.documento
			h4 Documento
			//- .panel
			//- 	.titulo Tamaño
			//- 	.controles.grupo
			//- 		.control
			//- 			label Ancho
			//- 			input.input(
			//- 				v-model="documentoAncho", type="number", step="10"
			//- 			)
			//- 		.control
			//- 			label Alto
			//- 			input(v-model="documentoAlto", type="number", step="10")

			.panel
				.controles
					.control
						label Fondo
						input.input(
							v-model="documentoFondo", type="color"
						)

		.objeto(v-if="objeto")
			h4 Propiedades
			.panel(v-if="objeto.tag=='p'" )
				.control.vertical
					label Texto
					textarea(:value="objeto.texto", rows="3",  @change="actualizarPropiedades({'texto': $event.target.value})")

			.panel(v-if="objeto.tag=='img'" )
				.control.vertical
					label Ruta
					input(v-model="src", type="text")

			//- .panel
			//- 	.titulo Posicion
			//- 	.controles.grupo
			//- 		.control
			//- 			label X
			//- 			input.input(
			//- 				v-model="left", type="number"
			//- 			)
			//- 		.control
			//- 			label Y
			//- 			input(v-model="top", type="number")

			//- .panel
			//- 	.titulo Tamaño
			//- 	.controles.grupo
			//- 		.control
			//- 			label Ancho
			//- 			input(v-model="width", type="number")
			//- 		.control
			//- 			label Alto
			//- 			input(v-model="height", type="number")

			.panel
				.titulo Colores
				.controles
					.control(v-if="objeto.tag=='p'" )
						label Color de Texto
						input(v-model="color", type="color")
					.control
						label Color de fondo
						input(v-model="backgroundColor", type="color")


			//- .panel
			//- 	.titulo Colores
			//- 	.controles
			//- 		.control(v-if="objeto.tag=='p'" )
			//- 			label Color de Texto
			//- 			input(v-model="color", type="color")
			//- 		.control
			//- 			label Color de fondo
			//- 			input(v-model="backgroundColor", type="color")


			//- .panel(v-if="objeto.tag=='p'" )
			//- 	.titulo Fuente
			//- 	.controles
			//- 		.control
			//- 			label Relleno
			//- 			input(v-model="padding", type="number")
			//- 		.control
			//- 			label Tamaño de letra
			//- 			input(v-model="fontSize", type="number")
			//- 		.control
			//- 			label Interlineado
			//- 			input(v-model="lineHeight", type="number", step="0.1")

			//- .panel(v-if="objeto.tag=='img'" )
			//- 	.controles
			//- 		.control
			//- 			label Ajuste
			//- 			select(v-model="objectFit")
			//- 				option(value="cover" selected) Estirar
			//- 				option(value="contain") Ajustar
			//- 		.control
			//- 			label Alineacion
			//- 			select(v-model="objectPosition")
			//- 				option(value="top left" selected) Arriba Izquierda
			//- 				option(value="bottom left") Abajo Izquierda
			//- 				option(value="center center") Centro
			//- 				option(value="top right" selected) Arriba Derecha
			//- 				option(value="bottom right") Abajo Derecha
			//- .panel.permisos
			//- 	.titulo Permisos
			//- 	.controles
			//- 		.control
			//- 			input(type="checkbox", v-model="movible")
			//- 			label Se puede mover
			//- 		.control
			//- 			input(type="checkbox", v-model="redimensionable")
			//- 			label Se puede redimensional
			//- 		.control
			//- 			input(type="checkbox", v-model="editable")
			//- 			label Se puede editar
</template>


<script>
import { mapState, mapGetters, mapMutations, mapActions } from 'vuex'


export default {

	computed: {
		estilo:{
			get(){ return this.objeto.estilo }
		},
		atributos:{
			get(){ return this.objeto.atributos }
		},
		permisos:{
			get(){ return this.objeto.permisos }
		},
		top:{
			// get(){ return this.objeto ? parseInt(this.objeto.top) : 0 },
			get(){
				return parseInt(this.estilo.top)
			},
			set(valor){
				this.actualizarEstilo({top:`${valor}px`})
			}
		},
		left:{
			get(){ return parseInt(this.estilo.left) },
			set(valor){ this.actualizarEstilo({left:`${valor}px`}) }
		},
		width:{
			get(){ return parseInt(this.estilo.width) },
			set(valor){ this.actualizarEstilo({width:`${valor}px`}) }
		},
		height:{
			get(){ return parseInt(this.estilo.height) },
			set(valor){ this.actualizarEstilo({height:`${valor}px`}) }
		},
		padding:{
			get(){ return parseInt(this.estilo.padding) || 0 },
			set(valor){ this.actualizarEstilo({padding:`${valor}px`}) }
		},
		fontSize:{
			get(){ return parseInt(this.estilo.fontSize) || 12 },
			set(valor){ this.actualizarEstilo({fontSize:`${valor}px`}) }
		},
		lineHeight:{
			get(){ return parseFloat(this.estilo.lineHeight) || 1 },
			set(valor){ this.actualizarEstilo({lineHeight:valor}) }
		},
		color:{
			get(){ return this.estilo.color },
			set(valor){ this.actualizarEstilo({color:valor}) }
		},
		backgroundColor:{
			get(){ return this.estilo.backgroundColor },
			set(valor){ this.actualizarEstilo({backgroundColor:valor}) }
		},
		objectFit:{
			get(){ return this.estilo.objectFit || "cover" },
			set(valor){ this.actualizarEstilo({objectFit:valor}) }
		},
		objectPosition:{
			get(){ return this.estilo.objectPosition || "top left" },
			set(valor){ this.actualizarEstilo({objectPosition:valor}) }
		},
		src:{
			get(){ return this.atributos.src },
			set(valor){ this.actualizarAtributos({src:valor}) }
		},
		documentoAncho:{
			get(){ return parseInt(this.pagina.ancho) },
			set(valor){ this.actualizarPagina({ancho:parseInt(valor)}) }
		},
		documentoAlto:{
			get(){ return parseInt(this.pagina.alto) },
			set(valor){ this.actualizarPagina({alto:parseInt(valor)}) }
		},
		documentoFondo:{
			get(){ return this.pagina.fondo },
			set(valor){ this.actualizarPagina({fondo:valor}) }
		},

		movible:{
			get(){ return this.permisos.movible },
			set(valor){ this.actualizarPermisos({movible:valor}) }
		},

		redimensionable:{
			get(){ return this.permisos.redimensionable },
			set(valor){ this.actualizarPermisos({redimensionable:valor}) }
		},

		editable:{
			get(){ return this.permisos.editable },
			set(valor){ this.actualizarPermisos({editable:valor}) }
		},

		...mapGetters({
			pagina: "contenido/actual",
			objeto: "contenido/activo"
		}),

	},
	methods:{
		obtenerCifra(texto){
			const regex =  /^(\d+(\.\d+)?)/
			var arr = regex.exec(texto)
			// console.log(arr)
			return arr ? arr[0] : 0
		},
		textoChange(evt){
			this.texto(evt.target.value)
		},
		actualizar(propiedad, valor){
			console.debug(arguments)
		},
		...mapMutations({
			// actualizarEstilo: "contenido/actualizarEstilo",
			actualizarPropiedades: "contenido/actualizarPropiedades",
			actualizarPermisos: "contenido/actualizarPermisos",
		}),
		...mapActions({
			actualizarEstilo: "editor/actualizarEstiloElemento",
			actualizarAtributos: "editor/actualizarAtributosElemento",
			actualizarPagina: "editor/actualizarPagina",
			// actualizarPagina: "editor/actualizarPagina",
		})

	}

}
</script>



<style lang="stylus" scoped>
#propiedades
	background-color #333
	max-width 300px
	padding .5rem

	h4
		margin-bottom .5rem
		font-weight bold
		color white



	*
		// outline 1px solid red

button
	padding .2em .5em
	border 1px solid rgba(255,255,225,0.5)

label
	display: block
	font-size 13px

.panel
	border-bottom: 1px solid rgba(255,255,225,0.3)
	padding .5rem

.controles
	// @apply flex

	&.grupo
		display flex

.titulo
	margin-bottom .5rem
	font-weight bold
	color #CD1318

.control
	flex 1 1 auto
	margin-bottom .5rem
	display flex
	align-items center

	&.vertical
		flex-direction column
		align-items stretch

	label
		// @apply flex-none
		flex 0 0 auto
		padding 0 .5em
		color white

	input[type="text"]
	input[type="url"]
	input[type="number"]
	select
		display block
		flex 0 1 auto
		width 100%
		// appearance none
		border 1px solid rgba(255,255,225,0.5)
		border-radius .2em
		padding .2em .5em
		// @apply p-1 shadow appearance-none border rounded

		& + label
			text-align left

		.permisos &
			flex 0 1 auto

	input[type="color"]
		padding 0
		border-radius .2em



</style>
